# #!/usr/bin/env python3


from kivy.app import App
from kivy.uix.boxlayout import BoxLayout
from kivy.uix.button import Button
from kivy.core.window import Window
import random
from kivy.clock import Clock

Window.size = (1000, 200)

class Kaart(Button):
    def __init__(self, waarde, nr, *args, **kwargs):
        super(Kaart, self).__init__(*args, **kwargs)
        self.waarde = waarde
        self.nr = nr
        self.open = False

class MainWindow(BoxLayout):
    def __init__(self):
        super().__init__()
        self.waarde = None
        self.selected_cards = []

        keuzes = ["skibidi", "sigma", "Gandalf", "ladyboy", "Tenen", "Doris"] * 2
        random.shuffle(keuzes)
        for nr, krt in enumerate(keuzes):
            self.kaart = Kaart(waarde=krt, nr=nr+1, text=f"Kaart {nr+1}")
            self.kaart.bind(on_press=self.handle_button_clicked1)
            self.add_widget(self.kaart)

    def handle_button_clicked1(self, event):
        if event.open:
            event.text = f"Kaart {event.nr}"
        else:
            event.text = event.waarde
        event.open = not event.open
        self.selected_cards.append(event)
        if len(self.selected_cards) == 2:
            if self.selected_cards[0].waarde!= self.selected_cards[1].waarde:
                Clock.schedule_once(self.flip_cards_back, 1)
            else:
                self.selected_cards = []

    def flip_cards_back(self, dt):
        for card in self.selected_cards:
            card.text = f"Kaart {card.nr}"
            card.open = False
        self.selected_cards = []

class MyApp(App):
    def build(self):
        self.title = "Memory"
        return MainWindow()

app = MyApp()
app.run()

# # bronnen:
# #       https://kivy.org/
# #       https://www.pythonguis.com/tutorials/getting-started-kivy/
# #       https://www.pythonguis.com/faq/which-python-gui-library/
# #       Blackbox.ai
